diff mbox series

[v2,15/16] generic: add race test that mmap write to source of reflink

Message ID 20211125074752.274176-16-ruansy.fnst@fujitsu.com (mailing list archive)
State New, archived
Headers show
Series generic: add some mmap CoW tests | expand

Commit Message

Shiyang Ruan Nov. 25, 2021, 7:47 a.m. UTC
Test for races or FS corruption when mmap writing to a file that's also
the source of a reflink operation. (MMAP version of generic/167,166)

Signed-off-by: Shiyang Ruan <ruansy.fnst@fujitsu.com>
---
 tests/generic/914     | 64 +++++++++++++++++++++++++++++++++++++++++++
 tests/generic/914.out |  4 +++
 2 files changed, 68 insertions(+)
 create mode 100755 tests/generic/914
 create mode 100644 tests/generic/914.out

Comments

Darrick J. Wong Dec. 7, 2021, 12:30 a.m. UTC | #1
On Thu, Nov 25, 2021 at 03:47:51PM +0800, Shiyang Ruan wrote:
> Test for races or FS corruption when mmap writing to a file that's also
> the source of a reflink operation. (MMAP version of generic/167,166)
> 
> Signed-off-by: Shiyang Ruan <ruansy.fnst@fujitsu.com>
> ---
>  tests/generic/914     | 64 +++++++++++++++++++++++++++++++++++++++++++
>  tests/generic/914.out |  4 +++
>  2 files changed, 68 insertions(+)
>  create mode 100755 tests/generic/914
>  create mode 100644 tests/generic/914.out
> 
> diff --git a/tests/generic/914 b/tests/generic/914
> new file mode 100755
> index 00000000..c51c44c7
> --- /dev/null
> +++ b/tests/generic/914
> @@ -0,0 +1,64 @@
> +#! /bin/bash
> +# SPDX-License-Identifier: GPL-2.0
> +#
> +# FS QA Test No. 914
> +#
> +# Test for races or FS corruption when mmap writing to a file that's also
> +# the source of a reflink operation. (MMAP version of generic/167,166)
> +#
> +. ./common/preamble
> +_begin_fstest auto clone
> +
> +_register_cleanup "_cleanup" BUS
> +
> +# Import common functions.
> +. ./common/filter
> +. ./common/reflink
> +
> +# real QA test starts here
> +_require_scratch_reflink
> +_require_cp_reflink
> +
> +echo "Format and mount"
> +_scratch_mkfs > $seqres.full 2>&1
> +_scratch_mount >> $seqres.full 2>&1
> +
> +testdir=$SCRATCH_MNT/test-$seq
> +finished_file=/tmp/finished
> +rm -rf $finished_file
> +mkdir $testdir
> +
> +loops=1024
> +nr_loops=$((loops - 1))
> +blksz=65536
> +
> +echo "Initialize file"
> +echo >> $seqres.full
> +_pwrite_byte 0x61 0 $((loops * blksz)) $testdir/file1 >> $seqres.full
> +_scratch_cycle_mount
> +
> +# Snapshot creator...
> +snappy() {
> +	n=0
> +	while [ ! -e $finished_file ]; do
> +		out="$(_cp_reflink $testdir/file1 $testdir/snap_$n 2>&1)"

Just out of curiosity, did you notice any of the slow-writes effects
that caused Dave to add throttling to generic/166?  I'm kinda assuming
no since he only changed the directio write tester, but <shrug> now
you're the expert in this area. ;)

In any case, looks correct to me, so
Reviewed-by: Darrick J. Wong <djwong@kernel.org>

--D

> +		res=$?
> +		echo "$out" | grep -q "No space left" && break
> +		test -n "$out" && echo "$out"
> +		test $res -ne 0 && break
> +		n=$((n + 1))
> +	done
> +}
> +
> +echo "Snapshot a file undergoing mmap rewrite"
> +snappy &
> +seq $nr_loops -1 0 | while read i; do
> +	$XFS_IO_PROG -f -c "mmap -rw $((i * blksz)) $blksz" \
> +		-c "mwrite -S 0x63 $((i * blksz)) $blksz" $testdir/file1 >> $seqres.full
> +done
> +touch $finished_file
> +wait
> +
> +# success, all done
> +status=0
> +exit
> diff --git a/tests/generic/914.out b/tests/generic/914.out
> new file mode 100644
> index 00000000..1472055f
> --- /dev/null
> +++ b/tests/generic/914.out
> @@ -0,0 +1,4 @@
> +QA output created by 914
> +Format and mount
> +Initialize file
> +Snapshot a file undergoing mmap rewrite
> -- 
> 2.34.0
> 
> 
>
diff mbox series

Patch

diff --git a/tests/generic/914 b/tests/generic/914
new file mode 100755
index 00000000..c51c44c7
--- /dev/null
+++ b/tests/generic/914
@@ -0,0 +1,64 @@ 
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+#
+# FS QA Test No. 914
+#
+# Test for races or FS corruption when mmap writing to a file that's also
+# the source of a reflink operation. (MMAP version of generic/167,166)
+#
+. ./common/preamble
+_begin_fstest auto clone
+
+_register_cleanup "_cleanup" BUS
+
+# Import common functions.
+. ./common/filter
+. ./common/reflink
+
+# real QA test starts here
+_require_scratch_reflink
+_require_cp_reflink
+
+echo "Format and mount"
+_scratch_mkfs > $seqres.full 2>&1
+_scratch_mount >> $seqres.full 2>&1
+
+testdir=$SCRATCH_MNT/test-$seq
+finished_file=/tmp/finished
+rm -rf $finished_file
+mkdir $testdir
+
+loops=1024
+nr_loops=$((loops - 1))
+blksz=65536
+
+echo "Initialize file"
+echo >> $seqres.full
+_pwrite_byte 0x61 0 $((loops * blksz)) $testdir/file1 >> $seqres.full
+_scratch_cycle_mount
+
+# Snapshot creator...
+snappy() {
+	n=0
+	while [ ! -e $finished_file ]; do
+		out="$(_cp_reflink $testdir/file1 $testdir/snap_$n 2>&1)"
+		res=$?
+		echo "$out" | grep -q "No space left" && break
+		test -n "$out" && echo "$out"
+		test $res -ne 0 && break
+		n=$((n + 1))
+	done
+}
+
+echo "Snapshot a file undergoing mmap rewrite"
+snappy &
+seq $nr_loops -1 0 | while read i; do
+	$XFS_IO_PROG -f -c "mmap -rw $((i * blksz)) $blksz" \
+		-c "mwrite -S 0x63 $((i * blksz)) $blksz" $testdir/file1 >> $seqres.full
+done
+touch $finished_file
+wait
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/914.out b/tests/generic/914.out
new file mode 100644
index 00000000..1472055f
--- /dev/null
+++ b/tests/generic/914.out
@@ -0,0 +1,4 @@ 
+QA output created by 914
+Format and mount
+Initialize file
+Snapshot a file undergoing mmap rewrite